//======================================================================
// -- DecodeDoc.cpp--                                                    
//                                                                      
//  MVR-D2000                                                           
//  MPEG2vOXg[M@TvvO
//  MPEG2 program stream receiver sample program
//                                                                      
// Copyright (C) 2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO --                           
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// DecodeDoc.cpp : CDecodeDoc NX̓̒`s܂B
// DecodeDoc.cpp : implementation of the CDecodeDoc class

#include "stdafx.h"
#include "Decode_cEx.h"
#include "MainFrm.h"
#include "DecodeDoc.h"
#include "Dialog.h"
#include "MpegReceiver.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CDecodeDoc* g_pDoc = NULL;

/////////////////////////////////////////////////////////////////////////////
// CDecodeDoc

IMPLEMENT_DYNCREATE(CDecodeDoc, CDocument)

BEGIN_MESSAGE_MAP(CDecodeDoc, CDocument)
	//{{AFX_MSG_MAP(CDecodeDoc)
	ON_COMMAND(IDM_CONNECT, OnConnect)
	ON_UPDATE_COMMAND_UI(IDM_CONNECT, OnUpdateConnect)
	ON_COMMAND(IDM_DISCONNECT, OnDisconnect)
	ON_UPDATE_COMMAND_UI(IDM_DISCONNECT, OnUpdateDisconnect)
	ON_COMMAND(IDM_RECEIVE_START, OnReceiveStart)
	ON_UPDATE_COMMAND_UI(IDM_RECEIVE_START, OnUpdateReceiveStart)
	ON_COMMAND(IDM_RECEIVE_END, OnReceiveEnd)
	ON_UPDATE_COMMAND_UI(IDM_RECEIVE_END, OnUpdateReceiveEnd)
	ON_COMMAND(IDM_CONNECT_OPTION, OnConnectOption)
	ON_UPDATE_COMMAND_UI(IDM_CONNECT_OPTION, OnUpdateConnectOption)
	ON_COMMAND(IDM_RECEIVE_OPTION, OnReceiveOption)
	ON_UPDATE_COMMAND_UI(IDM_RECEIVE_OPTION, OnUpdateReceiveOption)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDecodeDoc NX̍\z/
// CDecodeDoc construction/destruction

CDecodeDoc::CDecodeDoc()
	: m_fState(decNone),
	m_pReceiver(NULL), m_nPort(1100), m_szAddress(_T("192.168.1.2")), m_szAddressRecvFrom(_T("192.168.1.1")),
	m_cbBsrBuff(CMpegReceiver::m_cbBuffDefault), m_cBsrBuff(CMpegReceiver::m_cBuffDefault), m_fRestarting(FALSE), m_pView(NULL), m_fCanRestart(FALSE)
{
	g_pDoc = this;

	m_pReceiver = new CMpegReceiver(GetDecId());
#ifdef _DELAYED_INIT
	VERIFY(m_pReceiver->Init(DecStatusCallback, DecErrorCallback));
#endif
	char szHost[MAX_PATH];
	hostent* pHostEnt;
	if (!gethostname(szHost, MAX_PATH) && (pHostEnt = gethostbyname(szHost))) {
		ASSERT(pHostEnt->h_addrtype == AF_INET && pHostEnt->h_length == 4);
		LPBYTE pAddr = (LPBYTE)pHostEnt->h_addr;
		m_szAddress.Format(_T("%u.%u.%u.%u"), *pAddr, *(pAddr + 1), *(pAddr + 2), *(pAddr + 3));
	}
	else
		SocketErrorMessageBox();
}

CDecodeDoc::~CDecodeDoc()
{
	OnReceiveEnd();
	OnDisconnect();
#ifdef _DELAYED_INIT
	VERIFY(m_pReceiver->Exit());
#endif
	delete m_pReceiver; m_pReceiver = NULL;

	g_pDoc = NULL;
}

BOOL CDecodeDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	m_fState = decDisconnected;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CDecodeDoc VAC[[V
// CDecodeDoc serialization

void CDecodeDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
		// TODO: add storing code here
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDecodeDoc NX̐ff
// CDecodeDoc diagnostics

#ifdef _DEBUG
void CDecodeDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDecodeDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDecodeDoc R}h
// CDecodeDoc commands

void CDecodeDoc::OnConnect()
{
	if (m_pReceiver->Connect(m_szAddress, m_nPort, m_szAddressRecvFrom))
		m_fState = decConnected;
}

void CDecodeDoc::OnUpdateConnect(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == decDisconnected);
}

void CDecodeDoc::OnDisconnect()
{
	if (m_pReceiver->Disconnect())
		m_fState = decDisconnected;
}

void CDecodeDoc::OnUpdateDisconnect(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == decConnected || m_fState == decStopped);
}

void CDecodeDoc::OnReceiveStart()
{
	if (m_pReceiver->ReceiveStart(m_cbBsrBuff, m_cBsrBuff))
	{
		m_fState = decStarted;
		m_fCanRestart = TRUE;
	}
}

void CDecodeDoc::OnUpdateReceiveStart(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == decConnected || m_fState == decStopped);
}

void CDecodeDoc::OnReceiveEnd()
{
	m_fCanRestart = FALSE;
	if (m_pReceiver->ReceiveStop())
		m_fState = decStopped;
}

void CDecodeDoc::OnUpdateReceiveEnd(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == decStarted);
}

void CDecodeDoc::OnConnectOption()
{
	CConnectOptionDlg Dlg;
	Dlg.m_szAddress = m_szAddress;
	Dlg.m_nPort = m_nPort;
	Dlg.m_szRecvFrom = m_szAddressRecvFrom;
	if (Dlg.DoModal() == IDOK) {
		m_szAddress = Dlg.m_szAddress;
		m_nPort = (WORD)Dlg.m_nPort;
		m_szAddressRecvFrom = Dlg.m_szRecvFrom;
	}
}

void CDecodeDoc::OnUpdateConnectOption(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == decDisconnected);
}

void CDecodeDoc::OnReceiveOption()
{
	CReceiveOptionDlg Dlg;
	Dlg.m_cbBsrBuff = m_cbBsrBuff; Dlg.m_cBsrBuff = m_cBsrBuff;
	if (Dlg.DoModal() == IDOK) {
		m_cbBsrBuff = Dlg.m_cbBsrBuff; m_cBsrBuff = Dlg.m_cBsrBuff;
	}
}

void CDecodeDoc::OnUpdateReceiveOption(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == decStopped || m_fState == decConnected || m_fState == decDisconnected);
}

// the following callbacks may be called in the context of the thread other than the one for theApp

void CDecodeDoc::OnDecStopped()
{
	m_fState = decStopped;
}

void CALLBACK CDecodeDoc::DecStatusCallback(UINT nDecId, DEC_STATUS_NOTIFY fStatus)
{
	if (!g_pDoc) return;

	if (fStatus == DEC_NOTIFY_STOP)
		g_pDoc->m_fCanRestart = FALSE;

	if (!g_pDoc->m_fRestarting)
	{
		CMainFrame* pFrame = (CMainFrame*)theApp.m_pMainWnd;
		if (pFrame)
			pFrame->PostMessage(MSG_DEC_STATUS, (WPARAM)nDecId, (LPARAM)fStatus);
	}
}

void CALLBACK CDecodeDoc::DecErrorCallback(UINT nDecId, ULONG ulError)
{
	if (g_pDoc && ulError == ERROR_THREAD)
	{
		g_pDoc->RestartDecoder();
	}
	else
	{
		CMainFrame* pFrame = (CMainFrame*)theApp.m_pMainWnd;
		if (pFrame)
			pFrame->PostMessage(MSG_DEC_ERROR, (WPARAM)nDecId, (LPARAM)ulError);
	}
}

void CDecodeDoc::RestartDecoder()
{
	if (!m_fCanRestart) return;
	m_fCanRestart = FALSE;

#ifdef __TRACEOUT
	TraceOut("RestartDecoder - Restarting decoder");
#endif

	VERIFY(m_pView);

	m_fRestarting = TRUE;

	if (m_fState == decStarted)
		OnReceiveEnd();
	if (m_fState == decConnected || m_fState == decStopped)
		OnDisconnect();

	SendMessage(m_pView->m_hWnd, MSG_DESTROY_OVERLAY, 0, 0);

	delete m_pReceiver; m_pReceiver = NULL;
	VERIFY(CMpegReceiver::Exit(GetDecId()));
	VERIFY(CMpegReceiver::CleanUp());

	VERIFY(CMpegReceiver::StartUp());
	VERIFY(CMpegReceiver::Init(GetDecId(), NULL, CDecodeDoc::DecStatusCallback, CDecodeDoc::DecErrorCallback));

	m_pReceiver = new CMpegReceiver(GetDecId());		

	SendMessage(m_pView->m_hWnd, MSG_CREATE_OVERLAY, 0, 0);

	CRect rc;
	GetWindowRect(AfxGetMainWnd()->m_hWnd, &rc);
	MoveWindow(AfxGetMainWnd()->m_hWnd, rc.left, rc.top, rc.Width(), rc.Height(), TRUE);

	OnConnect();
	OnReceiveStart();

#ifdef __TRACEOUT
	TraceOut("RestartDecoder - Restarting decoder done.");
#endif

	m_fRestarting = FALSE;
}
