//======================================================================
// -- OverlayView.cpp--                                                    
//                                                                      
//  MVR-D2000                                                           
//  MPEG2vOXg[M@TvvO
//  MPEG2 program stream receiver sample program
//                                                                      
// Copyright (C) 2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO --                           
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// OverlayView.cpp : COverlayView NX̓̒`s܂B
// OverlayView.cpp : implementation of the COverlayView class


#include "stdafx.h"
#include "Decode_cEx.h"

#include "DecodeDoc.h"
#include "OverlayView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COverlayView

IMPLEMENT_DYNCREATE(COverlayView, CView)

BEGIN_MESSAGE_MAP(COverlayView, CView)
	//{{AFX_MSG_MAP(COverlayView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_MOVE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP

	ON_MESSAGE(MSG_CREATE_OVERLAY, OnCreateOverlay)
	ON_MESSAGE(MSG_DESTROY_OVERLAY, OnDestroyOverlay)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COverlayView NX̍\z/
// COverlayView construction/destruction


COverlayView::COverlayView()
	: m_hWndOverlay(NULL)
{
}

COverlayView::~COverlayView()
{
}

BOOL COverlayView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COverlayView NX̕`
// COverlayView drawing

void COverlayView::OnDraw(CDC* pDC)
{
	CDecodeDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// COverlayView NX̐ff
// COverlayView diagnostics

#ifdef _DEBUG
void COverlayView::AssertValid() const
{
	CView::AssertValid();
}

void COverlayView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDecodeDoc* COverlayView::GetDocument()			// fobO o[W̓CCłB
												// non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDecodeDoc)));
	return (CDecodeDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COverlayView NX̃bZ[W nh
// COverlayView message handlers

int COverlayView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	CRect rc;
    GetClientRect(&rc);

	if (DEC_Can_Overlay_Window(GetDecId(), NULL, rc.Width(), rc.Height()) == DEC_SUCCESS) {
		DEC_Create_Overlay_Window(GetDecId(), m_hWnd, &m_hWndOverlay, 0, 0, rc.Width(), rc.Height());
		VERIFY(DEC_Start_Monitor(GetDecId()) == DEC_SUCCESS);
	}

	CDecodeDoc* pDoc = GetDocument();
	if (pDoc)
		pDoc->m_pView = this;

	return 0;
}

void COverlayView::OnDestroy()
{
	CView::OnDestroy();
	VERIFY(DEC_Stop_Monitor(GetDecId()) == DEC_SUCCESS);
	if (m_hWndOverlay) {
		VERIFY(DEC_Destroy_Overlay_Window(GetDecId()) == DEC_SUCCESS);
		m_hWndOverlay = NULL;
	}

	CDecodeDoc* pDoc = GetDocument();
	if (pDoc)
		pDoc->m_pView = NULL;
}

void COverlayView::OnMove(int x, int y)
{
	CView::OnMove(x, y);
	if (m_hWndOverlay) {
		CPoint pt(x, y);
		ClientToScreen(&pt);
		VERIFY(DEC_Move_Overlay_Window(GetDecId(), pt.x, pt.y) == DEC_SUCCESS);
	}
	else {
		CRect rc;
		GetClientRect(&rc);

		if (DEC_Can_Overlay_Window(GetDecId(), NULL, rc.Width(), rc.Height()) == DEC_SUCCESS) {
			DEC_Create_Overlay_Window(GetDecId(), m_hWnd, &m_hWndOverlay, 0, 0, rc.Width(), rc.Height());
			VERIFY(DEC_Start_Monitor(GetDecId()) == DEC_SUCCESS);
			if (m_hWndOverlay) {
				CPoint pt(x, y);
				ClientToScreen(&pt);
				VERIFY(DEC_Move_Overlay_Window(GetDecId(), pt.x, pt.y) == DEC_SUCCESS);
			}
		}
	}
}

void COverlayView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);
	if (m_hWndOverlay) {
		VERIFY(DEC_Resize_Overlay_Window(GetDecId(), cx, cy) == DEC_SUCCESS);
	}
	else {
		CRect rc;
		GetClientRect(&rc);

		if (DEC_Can_Overlay_Window(GetDecId(), NULL, rc.Width(), rc.Height()) == DEC_SUCCESS) {
			DEC_Create_Overlay_Window(GetDecId(), m_hWnd, &m_hWndOverlay, 0, 0, rc.Width(), rc.Height());
			VERIFY(DEC_Start_Monitor(GetDecId()) == DEC_SUCCESS);
			if (m_hWndOverlay) {
				VERIFY(DEC_Resize_Overlay_Window(GetDecId(), cx, cy) == DEC_SUCCESS);
			}
		}
	}
}

void COverlayView::OnDestroyOverlay(WPARAM wParam, LPARAM lParam)
{
	VERIFY(DEC_Stop_Monitor(GetDecId()) == DEC_SUCCESS);
	if (m_hWndOverlay) {
		VERIFY(DEC_Destroy_Overlay_Window(GetDecId()) == DEC_SUCCESS);
		m_hWndOverlay = NULL;
	}
}

void COverlayView::OnCreateOverlay(WPARAM wParam, LPARAM lParam)
{
	CRect rc;
    GetClientRect(&rc);
	if (DEC_Can_Overlay_Window(GetDecId(), NULL, rc.Width(), rc.Height()) == DEC_SUCCESS)
		DEC_Create_Overlay_Window(GetDecId(), m_hWnd, &m_hWndOverlay, 0, 0, rc.Width(), rc.Height());
	VERIFY(DEC_Start_Monitor(GetDecId()) == DEC_SUCCESS);

	CDecodeDoc* pDoc = GetDocument();
	if (pDoc)
		pDoc->m_pView = this;
}
