//======================================================================
// -- EncodeDoc.cpp --                                                    
//                                                                      
//  MVR-D2000                                                           
//@MPEG2vOXg[M    TvvO      
//  MPEG2 program stream sender sample program          
//                                                                      
// Copyright (C) 2000-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO --                           
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// EncodeDoc.cpp : CEncodeDoc NX̓̒`s܂B
// EncodeDoc.cpp : implementation of the CEncodeDoc class


#include "stdafx.h"
#include "Encode_cEx.h"
#include "MainFrm.h"
#include "EncodeDoc.h"
#include "Dialog.h"
#include "MpegSender.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CEncodeDoc* g_pDoc = NULL;

/////////////////////////////////////////////////////////////////////////////
// CEncodeDoc

IMPLEMENT_DYNCREATE(CEncodeDoc, CDocument)

BEGIN_MESSAGE_MAP(CEncodeDoc, CDocument)
	//{{AFX_MSG_MAP(CEncodeDoc)
	ON_COMMAND(IDM_CONNECT, OnConnect)
	ON_UPDATE_COMMAND_UI(IDM_CONNECT, OnUpdateConnect)
	ON_COMMAND(IDM_DISCONNECT, OnDisconnect)
	ON_UPDATE_COMMAND_UI(IDM_DISCONNECT, OnUpdateDisconnect)
	ON_COMMAND(IDM_SEND_START, OnSendStart)
	ON_UPDATE_COMMAND_UI(IDM_SEND_START, OnUpdateSendStart)
	ON_COMMAND(IDM_SEND_END, OnSendEnd)
	ON_UPDATE_COMMAND_UI(IDM_SEND_END, OnUpdateSendEnd)
	ON_COMMAND(IDM_CONNECT_OPTION, OnConnectOption)
	ON_UPDATE_COMMAND_UI(IDM_CONNECT_OPTION, OnUpdateConnectOption)
	ON_COMMAND(IDM_SEND_OPTION, OnSendOption)
	ON_UPDATE_COMMAND_UI(IDM_SEND_OPTION, OnUpdateSendOption)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEncodeDoc NX̍\z/
// CEncodeDoc construction/destruction

CEncodeDoc::CEncodeDoc()
	: m_fState(encNone),
	m_pSender(NULL), m_nPort(1100), m_szAddress(_T("192.168.1.1")), m_szAddressSendTo(_T("192.168.1.2")),
	m_cbBssBuff(CMpegSender::m_cbBuffDefault), m_cBssBuff(CMpegSender::m_cBuffDefault)
{
	g_pDoc = this;

	m_pSender = new CMpegSender(GetEncId());
#ifdef _DELAYED_INIT
	VERIFY(m_pSender->Init(EncStatusCallback, EncErrorCallback));
#endif
	char szHost[MAX_PATH];
	hostent* pHostEnt;
	if (!gethostname(szHost, MAX_PATH) && (pHostEnt = gethostbyname(szHost))) {
		ASSERT(pHostEnt->h_addrtype == AF_INET && pHostEnt->h_length == 4);
		LPBYTE pAddr = (LPBYTE)pHostEnt->h_addr;
		m_szAddress.Format(_T("%u.%u.%u.%u"), *pAddr, *(pAddr + 1), *(pAddr + 2), *(pAddr + 3));
	}
	else
		SocketErrorMessageBox();
}

CEncodeDoc::~CEncodeDoc()
{
	OnSendEnd();
	OnDisconnect();
#ifdef _DELAYED_INIT
	VERIFY(m_pSender->Exit());
#endif
	delete m_pSender; m_pSender = NULL;

	g_pDoc = NULL;
}

BOOL CEncodeDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	m_fState = encDisconnected;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CEncodeDoc VAC[[V
// CEncodeDoc serialization

void CEncodeDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
		// TODO: add storing code here
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CEncodeDoc NX̐ff
// CEncodeDoc diagnostics

#ifdef _DEBUG
void CEncodeDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CEncodeDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEncodeDoc R}h
// CEncodeDoc commands

void CEncodeDoc::OnConnect()
{
	if (m_pSender->Connect(m_szAddress, m_nPort, m_szAddressSendTo))
		m_fState = encConnected;
}

void CEncodeDoc::OnUpdateConnect(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == encDisconnected);
}

void CEncodeDoc::OnDisconnect()
{
	if (m_pSender->Disconnect())
		m_fState = encDisconnected;
}

void CEncodeDoc::OnUpdateDisconnect(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == encConnected || m_fState == encStopped);
}

void CEncodeDoc::OnSendStart()
{
	if (m_pSender->SendStart(m_cbBssBuff, m_cBssBuff))
		m_fState = encStarted;
}

void CEncodeDoc::OnUpdateSendStart(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == encConnected || m_fState == encStopped);
}

void CEncodeDoc::OnSendEnd()
{
	if (m_pSender->SendStop())
		m_fState = encStopped;
}

void CEncodeDoc::OnUpdateSendEnd(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == encStarted);
}

void CEncodeDoc::OnConnectOption()
{
	CConnectOptionDlg Dlg;
	Dlg.m_szAddress = m_szAddress;
	Dlg.m_nPort = m_nPort;
	Dlg.m_szSendTo = m_szAddressSendTo;
	if (Dlg.DoModal() == IDOK) {
		m_szAddress = Dlg.m_szAddress;
		m_nPort = (WORD)Dlg.m_nPort;
		m_szAddressSendTo = Dlg.m_szSendTo;
	}
}

void CEncodeDoc::OnUpdateConnectOption(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == encDisconnected);
}

void CEncodeDoc::OnSendOption()
{
	ENC_VIDEO_ENCODE_PARAMETER_EX VideoParamEx;
	ENC_AUDIO_ENCODE_PARAMETER AudioParam;
	CSendOptionDlg Dlg;
	if (ENC_Get_Video_Encode_Parameter_Ex(GetEncId(), &VideoParamEx) != ENC_SUCCESS ||
		ENC_Get_Audio_Encode_Parameter(GetEncId(), &AudioParam) != ENC_SUCCESS)
		goto error;
	Dlg.m_cbBssBuff = m_cbBssBuff; Dlg.m_cBssBuff = m_cBssBuff;
	Dlg.m_dwVideoBitRate = VideoParamEx.EncodeParam.dwBitrate;
	Dlg.m_dwAudioBitRate = AudioParam.AudioBitrate;
	if (Dlg.DoModal() == IDOK) {
		m_cbBssBuff = Dlg.m_cbBssBuff; m_cBssBuff = Dlg.m_cBssBuff;
		if ((VideoParamEx.EncodeParam.fConvertType = Dlg.m_fConvertType) == ENCVEPARAM_CONVERT_TYPE_STANDARD)
		{
			if (Dlg.m_dwVideoBitRate < 4000000)
				VideoParamEx.EncodeParam.dwBitrate = 4000000;
			else
				VideoParamEx.EncodeParam.dwBitrate = Dlg.m_dwVideoBitRate;
		}
		else
		{
			if (Dlg.m_dwVideoBitRate > 8000000)
				VideoParamEx.EncodeParam.dwBitrate = 8000000;
			else
				VideoParamEx.EncodeParam.dwBitrate = Dlg.m_dwVideoBitRate;
		}
		switch (VideoParamEx.EncodeParam.fConvertType)
		{
		case ENCVEPARAM_CONVERT_TYPE_SIF:
			VideoParamEx.EncodeParam.wImageWidth = SIF_VIDEO_WIDTH;
			VideoParamEx.EncodeParam.wImageHeight = NTSC_VIDEO_HEIGHT / 2;
			break;
		case ENCVEPARAM_CONVERT_TYPE_HALF_D1:
			VideoParamEx.EncodeParam.wImageWidth = SIF_VIDEO_WIDTH;
			VideoParamEx.EncodeParam.wImageHeight = NTSC_VIDEO_HEIGHT;
			break;
		default:
			VideoParamEx.EncodeParam.wImageWidth = VIDEO_WIDTH;
			VideoParamEx.EncodeParam.wImageHeight = NTSC_VIDEO_HEIGHT;
		}

		AudioParam.AudioBitrate = (int)Dlg.m_dwAudioBitRate;
		//VideoParamEx.fGopComplete = Dlg.m_fGopComplete;
		if (ENC_Set_Video_Encode_Parameter_Ex(GetEncId(), &VideoParamEx) != ENC_SUCCESS ||
			ENC_Set_Audio_Encode_Parameter(GetEncId(), &AudioParam) != ENC_SUCCESS)
			goto error;
	}
	goto done;
error:
	EncErrorMessageBox();
done:
	;
}

void CEncodeDoc::OnUpdateSendOption(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(m_fState == encStopped || m_fState == encConnected || m_fState == encDisconnected);
}

// the following callbacks may be called in the context of the thread other than the one for theApp

void CALLBACK CEncodeDoc::EncStatusCallback(UINT nEncId, ENC_STATUS_NOTIFY fStatus)
{
	if (g_pDoc)
	{
		if (g_pDoc->m_fState != encNone)
		{
			CMainFrame* pFrame = (CMainFrame*)theApp.m_pMainWnd;
			if (pFrame)
				pFrame->PostMessage(MSG_ENC_STATUS, (WPARAM)nEncId, (LPARAM)fStatus);
		}
	}
}

void CALLBACK CEncodeDoc::EncErrorCallback(UINT nEncId, ULONG ulError)
{
	if (ulError == SOCKET_ERROR)
	{
		if (g_pDoc)
		{
			g_pDoc->m_fState = encNone;
			g_pDoc->OnSendEnd();
			g_pDoc->OnDisconnect();
			WSACleanup();		
			WSADATA WsaData;
			if (WSAStartup(MAKEWORD(2, 0), &WsaData) || LOBYTE(WsaData.wVersion) != 2 || HIBYTE(WsaData.wVersion) != 0)
				return;
			g_pDoc->OnConnect();
			g_pDoc->OnSendStart();
		}
	}
	else
	{
		CMainFrame* pFrame = (CMainFrame*)theApp.m_pMainWnd;
		if (pFrame)
			pFrame->PostMessage(MSG_ENC_ERROR, (WPARAM)nEncId, (LPARAM)ulError);
	}
}


BOOL CEncodeDoc::CanCloseFrame(CFrameWnd* pFrame) 
{
	if (m_fState == encStarted)
		return FALSE;
	else
		return TRUE;
}
