
// MpegTransfer.h : MPEG program stream transfer class definitions
// Copyright (C) 2005 Canopus Co., Ltd. All rights reserved.

#include <winsock2.h>
#include <atlconv.h> // to use string conversion (between ANSI and UNICODE) macros

class CMpegTransfer : public CObject
{
	DECLARE_DYNAMIC(CMpegTransfer)

// attributes
protected:
	static WORD m_wWsaVersion; // windows socket version #, or 0 if WSAStartup fails

	UINT m_nId; // identifier
	enum SenderState {
		trsDisconnected, trsConnected, trsStarting, trsStarted, trsStopping, trsStopped
	};
	SenderState m_fState;
	SOCKET m_hSocket;
	WSAEVENT m_hEvent;
	WORD m_nPort;
	SOCKADDR_IN m_Addr;
	SOCKADDR_IN m_AddrOpposite;
	DWORD m_cbBuff; // BSS / BSR buffer size in bytes
	DWORD m_cBuff; // BSS / BSR default buffer count

public:
	static const DWORD m_cbBuffDefault; // default BSS / BSR buffer size in bytes
	static const DWORD m_cBuffDefault; //default BSS / BSR buffer count

// operations
public:
	CMpegTransfer(UINT nId = 1);
	virtual ~CMpegTransfer();
	static BOOL StartUp();
	static BOOL CleanUp();
	static BOOL SetSockAddrIn(LPCTSTR pszAddress, WORD nPort, LPSOCKADDR_IN pAddr);
	static int SendOverlapped(SOCKET hSocket, int fSocketType, LPVOID pBuff, DWORD cbBuff, LPDWORD pcbSent,
		LPSOCKADDR_IN pAddr = NULL);
	static int ReceiveOverlapped(SOCKET hSocket, int fSocketType, LPVOID pBuff, DWORD cbBuff, LPDWORD pcbReceived,
		LPSOCKADDR_IN pAddr = NULL);

	operator SOCKET();
	LPSOCKADDR_IN Addr();
	LPSOCKADDR_IN AddrOpposite();
	virtual BOOL Connect(LPCTSTR pszAddress, WORD nPort, LPCTSTR pszAddressOpposite);
	virtual BOOL Disconnect();
};

inline CMpegTransfer::operator SOCKET()
	{return m_hSocket;}
inline LPSOCKADDR_IN CMpegTransfer::Addr()
	{return &m_Addr;}
inline LPSOCKADDR_IN CMpegTransfer::AddrOpposite()
	{return &m_AddrOpposite;}

