//======================================================================
// -- AudioDlg.cpp --                                                   
//                                                                      
//  MVR-D2000                                                           
//                                  fR[h    TvvO      
//                                  Decode      sample program          
//                                                                      
// Copyright (C) 1999-2005 Canopus Co., Ltd. All rights reserved.       
//======================================================================
//                                                                      
// -- TvvOgpɂȂO ---                          
// -- Before use this sample program... --                              
//                                                                      
// ̃TvvÓAJm[vXig߂ɂgpB 
//  Please use this sample progeam to use products of canopus.          
//                                                                      
//======================================================================
// AudioDlg.cpp : Cve[V t@C
// AudioDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Decode.h"
#include "AudioDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern int	DEC_ID;

/////////////////////////////////////////////////////////////////////////////
// CAudioDlg Dialog


CAudioDlg::CAudioDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CAudioDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CAudioDlg)
    //}}AFX_DATA_INIT
}


void CAudioDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAudioDlg)
    DDX_Control(pDX, IDC_EDIT_RIGHT, m_EditRight);
    DDX_Control(pDX, IDC_EDIT_LEFT, m_EditLeft);
    DDX_Control(pDX, IDC_CHECK_MUTE, m_CheckMute);
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAudioDlg, CDialog)
    //{{AFX_MSG_MAP(CAudioDlg)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAudioDlg message handler

//----------------------------------------------------------------------
// #[ CAudioDlg::OnInitDialog ]                                         
//                                                                      
// @\     I[fBI̐ݒ                                            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE                                            
//                      FALSE                                           
//                                                                      
//----------------------------------------------------------------------
// #[ CAudioDlg::OnInitDialog ]                                         
//                                                                      
//  Function:   Initialize audio dialog                                 
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   BOOL    TRUE                                    
//                              FALSE                                   
//                                                                      
//----------------------------------------------------------------------
BOOL CAudioDlg::OnInitDialog() 
{
    DEC_AUDIO_PARAMETER dec_audio_param;
    DEC_RETURN  dec_return;
    CString     strMessage;
    char    szText[16];

    CDialog::OnInitDialog();

    dec_return = DEC_Get_Audio_Parameter(DEC_ID, &dec_audio_param);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_GET_AUDIO);
        MessageBox(strMessage);
        return FALSE;
    }

    // ~[g
    // Check Mute
    m_CheckMute.SetCheck(dec_audio_param.fOutputMute ? 1: 0);

    // {[̒l
    // Set volume
    wsprintf(szText, "%d", dec_audio_param.dwLeftOutputAtt);
    m_EditLeft.SetWindowText(szText);
    wsprintf(szText, "%d", dec_audio_param.dwRightOutputAtt);
    m_EditRight.SetWindowText(szText);

	return TRUE;	// Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
					// O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
					// return TRUE unless you set the focus to a control
					// EXCEPTION: OCX Property Pages should return FALSE
}

//----------------------------------------------------------------------
// #[ CAudioDlg::OnOK ]                                                 
//                                                                      
// @\     I[fBI̐ݒLɂ                                
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CAudioDlg::OnOK ]                                                 
//                                                                      
//  Function:   Set audio parameters                                    
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CAudioDlg::OnOK() 
{
    DEC_AUDIO_PARAMETER dec_audio_param;
    DEC_RETURN  dec_return;
    CString     strMessage;
    char    szText[16];

    dec_return = DEC_Get_Audio_Parameter(DEC_ID, &dec_audio_param);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_SET_AUDIO);
        MessageBox(strMessage);
        return;
    }

    // ~[g
    // check mute
    dec_audio_param.fOutputMute = (m_CheckMute.GetCheck() ? TRUE: FALSE);

    // {[̒l
    // set volume
    m_EditLeft.GetWindowText(szText, sizeof(szText));
    dec_audio_param.dwLeftOutputAtt = atol(szText);
    m_EditRight.GetWindowText(szText, sizeof(szText));
    dec_audio_param.dwRightOutputAtt = atol(szText);

    // p[^ݒ肷
    // set audio parmeter
    dec_return = DEC_Set_Audio_Parameter(DEC_ID, &dec_audio_param);
    if(dec_return != DEC_SUCCESS)
    {
        strMessage.LoadString(IDS_ERROR_SET_AUDIO);
        MessageBox(strMessage);
        return;
    }

    CDialog::OnOK();
}
