// VideoEncExDlg.cpp : Cve[V t@C
// VideoEncExDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Encode_m.h"
#include "VideoEncExDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern	int	ENC_ID;

/////////////////////////////////////////////////////////////////////////////
// CVideoEncExDlg _CAO
// CDlgDecParam Dialog

CVideoEncExDlg::CVideoEncExDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVideoEncExDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVideoEncExDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CVideoEncExDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVideoEncExDlg)
	DDX_Control(pDX, IDC_CHECK_GOP_COMPLETE, m_Check_GOP_Complete);
    DDX_Control(pDX, IDC_CHECK_CLOSED_GOP, m_Check_Closed_GOP);
    DDX_Control(pDX, IDC_EDIT_GOP_M, m_Edit_GOP_M);
    DDX_Control(pDX, IDC_EDIT_GOP_N, m_Edit_GOP_N);
    DDX_Control(pDX, IDC_EDIT_HEIGHT, m_Edit_Height);
    DDX_Control(pDX, IDC_EDIT_WIDTH, m_Edit_Width);
    DDX_Control(pDX, IDC_EDIT_TOP, m_Edit_Top);
    DDX_Control(pDX, IDC_EDIT_BITRATE_PEAK, m_Edit_Bitrate_Peak);
    DDX_Control(pDX, IDC_EDIT_BITRATE, m_Edit_Bitrate);
    DDX_Control(pDX, IDC_EDIT_LEFT, m_Edit_Left);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVideoEncExDlg, CDialog)
	//{{AFX_MSG_MAP(CVideoEncExDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoEncExDlg bZ[W nh
// CVideoEncExDlg message handlers

//----------------------------------------------------------------------
// #[ CVideoEncExDlg::OnInitDialog ]                                    
//                                                                      
// @\     grfIGR[hp[^̐ݒ                        
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    BOOL    TRUE                                            
//                      FALSE                                           
//                                                                      
//----------------------------------------------------------------------
// #[ CVideoEncExDlg::OnInitDialog ]                                    
//                                                                      
//  Function:   Initialize video encode dialog                          
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   BOOL    TRUE                                    
//                              FALSE                                   
//                                                                      
//----------------------------------------------------------------------
BOOL CVideoEncExDlg::OnInitDialog() 
{
    CDialog::OnInitDialog();
    
    ENC_VIDEO_ENCODE_PARAMETER_EX2  enc_video_param;
    ENC_RETURN  enc_return;
    CString     strMessage;
    char    szText[32];

    CDialog::OnInitDialog();

    // rfIGR[hp[^̎擾
    // Get video encode parameters
	enc_video_param.dwSize = sizeof(ENC_VIDEO_ENCODE_PARAMETER_EX2);
    enc_return = ENC_Get_Video_Encode_Parameter_Ex2(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_GET_PARAMETER);
        MessageBox(strMessage);
        return FALSE;
    }

    // MPEG
    switch(enc_video_param.EncodeParamEx.EncodeParam.V_CodingMode)
    {
    case ENCVEPARAM_V_CODING_MODE_MPEG1:
        CheckRadioButton(IDC_RADIO_MPEG1, IDC_RADIO_MPEG2, IDC_RADIO_MPEG1);
        break;
    default:
        CheckRadioButton(IDC_RADIO_MPEG1, IDC_RADIO_MPEG2, IDC_RADIO_MPEG2);
        break;
    }

    // vt@Cƃx̐ݒ
    // Set Profile and Level
    switch(enc_video_param.EncodeParamEx.EncodeParam.fProfileAndLevel)
    {
    case ENCVEPARAM_PROFILE_AND_LEVEL_MP_ML:
        CheckRadioButton(IDC_RADIO_MPML, IDC_RADIO_SPML, IDC_RADIO_MPML);
        break;
    case ENCVEPARAM_PROFILE_AND_LEVEL_MP_LL:
        CheckRadioButton(IDC_RADIO_MPML, IDC_RADIO_SPML, IDC_RADIO_MPLL);
        break;
    case ENCVEPARAM_PROFILE_AND_LEVEL_SP_ML:
        CheckRadioButton(IDC_RADIO_MPML, IDC_RADIO_SPML, IDC_RADIO_SPML);
        break;
    default:
        break;
    }

    // rfItH[}bg̐ݒ
    // Set video format
    switch(enc_video_param.EncodeParamEx.EncodeParam.fConvertType)
    {
    case ENCVEPARAM_CONVERT_TYPE_STANDARD:
        CheckRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1, IDC_RADIO_STANDARD);
        break;
    case ENCVEPARAM_CONVERT_TYPE_SIF:
        CheckRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1, IDC_RADIO_SIF);
        break;
    case ENCVEPARAM_CONVERT_TYPE_HALF_D1:
        CheckRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1, IDC_RADIO_HALFD1);
        break;
    default:
        break;
    }

    // CBR / VBR ̐ݒ
    // CBR or VBR...
    switch(enc_video_param.EncodeParamEx.EncodeParam.EncodeType)
    {
    case ENCVEPARAM_ENCODE_TYPE_CBR:
        CheckRadioButton(IDC_RADIO_CBR, IDC_RADIO_VBR, IDC_RADIO_CBR);
        break;
    default:
        CheckRadioButton(IDC_RADIO_CBR, IDC_RADIO_VBR, IDC_RADIO_VBR);
        break;
    }

    // GOP p^[̐ݒ
    // Set GOP Pattern
    switch(enc_video_param.EncodeParamEx.EncodeParam.GopPattern)
    {
    case ENCVEPARAM_GOP_PATTERN_IFRAME:
        CheckRadioButton(IDC_RADIO_IFRAME, IDC_RADIO_IBBP, IDC_RADIO_IFRAME);
        break;
    default:
        CheckRadioButton(IDC_RADIO_IFRAME, IDC_RADIO_IBBP, IDC_RADIO_IBBP);
        break;
    }

    // tB[hI[_[̐ݒ
	// 
    if (enc_video_param.fBottomFieldFirst != FALSE)
    {
        CheckRadioButton(IDC_RADIO_BT_FIRST, IDC_RADIO_TOP_FIRST, IDC_RADIO_BT_FIRST);
    }
	else
	{
        CheckRadioButton(IDC_RADIO_BT_FIRST, IDC_RADIO_TOP_FIRST, IDC_RADIO_TOP_FIRST);
	}

    // GOP /񊮌[h̐ݒ
	// Set GOP Complete
	m_Check_GOP_Complete.SetCheck(enc_video_param.EncodeParamEx.fGopComplete ? 1 : 0);
    
	// Closed GOP̐ݒ
	// Set Closed GOP
    m_Check_Closed_GOP.SetCheck(enc_video_param.EncodeParamEx.fClosedGop ? 1 : 0);

    // Set Edit box...
    wsprintf(szText, "%ld", enc_video_param.EncodeParamEx.EncodeParam.wImageLeft);
    m_Edit_Left.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.EncodeParamEx.EncodeParam.wImageTop);
    m_Edit_Top.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.EncodeParamEx.EncodeParam.wImageWidth);
    m_Edit_Width.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.EncodeParamEx.EncodeParam.wImageHeight);
    m_Edit_Height.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.EncodeParamEx.EncodeParam.dwBitrate);
    m_Edit_Bitrate.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.EncodeParamEx.dwVbrPeak);
    m_Edit_Bitrate_Peak.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.EncodeParamEx.cPictureInterval);
    m_Edit_GOP_M.SetWindowText(szText);
    wsprintf(szText, "%ld", enc_video_param.EncodeParamEx.cPicturePerGop);
    m_Edit_GOP_N.SetWindowText(szText);
    
    return TRUE;	// Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
					// O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
					// return TRUE unless you set the focus to a control
					// EXCEPTION: OCX Property Pages should return FALSE
}

//----------------------------------------------------------------------
// #[ CVideoEncExDlg::OnOK ]                                            
//                                                                      
// @\     grfIGR[hp[^̐ݒLɂ            
//                                                                      
//  F      Ȃ                                                    
//                                                                      
//  ߂lF    Ȃ                                                    
//                                                                      
//----------------------------------------------------------------------
// #[ CVideoEncExDlg::OnOK ]                                            
//                                                                      
//  Function:   Set video encode parameter ex                           
//                                                                      
//      Parameters:     none                                            
//                                                                      
//      Return value:   none                                            
//                                                                      
//----------------------------------------------------------------------
void CVideoEncExDlg::OnOK() 
{
    ENC_VIDEO_ENCODE_PARAMETER_EX2  enc_video_param;
    ENC_RETURN  enc_return;
    CString     strMessage;
    char    szText[32];
    int     nID;

    // rfIGR[hp[^̎擾
    // Get video encode parameters
	enc_video_param.dwSize = sizeof(ENC_VIDEO_ENCODE_PARAMETER_EX2);
    enc_return = ENC_Get_Video_Encode_Parameter_Ex2(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_GET_PARAMETER);
        MessageBox(strMessage);
        return;
    }

    // MPEG
    nID = GetCheckedRadioButton(IDC_RADIO_MPEG1, IDC_RADIO_MPEG2);
    if(nID == IDC_RADIO_MPEG1)
        enc_video_param.EncodeParamEx.EncodeParam.V_CodingMode = ENCVEPARAM_V_CODING_MODE_MPEG1;
    else
        enc_video_param.EncodeParamEx.EncodeParam.V_CodingMode = ENCVEPARAM_V_CODING_MODE_MPEG2;

    // vt@Cƃx̐ݒ
    // Set Profile and Level
    nID = GetCheckedRadioButton(IDC_RADIO_MPML, IDC_RADIO_SPML);
    switch(nID)
    {
    case IDC_RADIO_MPML:
        enc_video_param.EncodeParamEx.EncodeParam.fProfileAndLevel = ENCVEPARAM_PROFILE_AND_LEVEL_MP_ML;
        break;
    case IDC_RADIO_MPLL:
        enc_video_param.EncodeParamEx.EncodeParam.fProfileAndLevel = ENCVEPARAM_PROFILE_AND_LEVEL_MP_LL;
        break;
    default:
        enc_video_param.EncodeParamEx.EncodeParam.fProfileAndLevel = ENCVEPARAM_PROFILE_AND_LEVEL_SP_ML;
        break;
    }

    // rfItH[}bg̐ݒ
    // Set video format
    nID = GetCheckedRadioButton(IDC_RADIO_STANDARD, IDC_RADIO_HALFD1);
    switch(nID)
    {
    case IDC_RADIO_STANDARD:
        enc_video_param.EncodeParamEx.EncodeParam.fConvertType = ENCVEPARAM_CONVERT_TYPE_STANDARD;
        break;
    case IDC_RADIO_SIF:
        enc_video_param.EncodeParamEx.EncodeParam.fConvertType = ENCVEPARAM_CONVERT_TYPE_SIF;
        break;
    default:
        enc_video_param.EncodeParamEx.EncodeParam.fConvertType = ENCVEPARAM_CONVERT_TYPE_HALF_D1;
        break;
    }

    // CBR / VBR ̐ݒ
    // CBR or VBR...
    nID = GetCheckedRadioButton(IDC_RADIO_CBR, IDC_RADIO_VBR);
    if(nID == IDC_RADIO_CBR)
        enc_video_param.EncodeParamEx.EncodeParam.EncodeType = ENCVEPARAM_ENCODE_TYPE_CBR;
    else
        enc_video_param.EncodeParamEx.EncodeParam.EncodeType = ENCVEPARAM_ENCODE_TYPE_VBR;

    // GOP p^[̐ݒ
    // Set GOP pattern
    nID = GetCheckedRadioButton(IDC_RADIO_IFRAME, IDC_RADIO_IBBP);
    if(nID == IDC_RADIO_IFRAME)
        enc_video_param.EncodeParamEx.EncodeParam.GopPattern = ENCVEPARAM_GOP_PATTERN_IFRAME;
    else
        enc_video_param.EncodeParamEx.EncodeParam.GopPattern = ENCVEPARAM_GOP_PATTERN_IBBP;


    // tB[hI[_[̐ݒ
    // 
    nID = GetCheckedRadioButton(IDC_RADIO_BT_FIRST, IDC_RADIO_TOP_FIRST);
    if(nID == IDC_RADIO_BT_FIRST)
		enc_video_param.fBottomFieldFirst = TRUE;
    else
		enc_video_param.fBottomFieldFirst = FALSE;

    // GOP /񊮌[h̐ݒ
	// Set GOP Complete
	if(m_Check_GOP_Complete.GetCheck() == 1)
		enc_video_param.EncodeParamEx.fGopComplete = TRUE;
	else
		enc_video_param.EncodeParamEx.fGopComplete = FALSE;

	// Closed GOP̐ݒ
    // Set Closed GOP
	if(m_Check_Closed_GOP.GetCheck() == 1)
		enc_video_param.EncodeParamEx.fClosedGop = TRUE;
	else
		enc_video_param.EncodeParamEx.fClosedGop = FALSE;

    // Set Edit Box...
    m_Edit_Left.GetWindowText(szText,sizeof(szText));
    enc_video_param.EncodeParamEx.EncodeParam.wImageLeft = atoi(szText);
    m_Edit_Top.GetWindowText(szText,sizeof(szText));
    enc_video_param.EncodeParamEx.EncodeParam.wImageTop = atoi(szText);
    m_Edit_Width.GetWindowText(szText,sizeof(szText));
    enc_video_param.EncodeParamEx.EncodeParam.wImageWidth = atoi(szText);
    m_Edit_Height.GetWindowText(szText,sizeof(szText));
    enc_video_param.EncodeParamEx.EncodeParam.wImageHeight = atoi(szText);
    m_Edit_Bitrate.GetWindowText(szText,sizeof(szText));
    enc_video_param.EncodeParamEx.EncodeParam.dwBitrate = atol(szText);
    m_Edit_Bitrate_Peak.GetWindowText(szText,sizeof(szText));
    enc_video_param.EncodeParamEx.dwVbrPeak = atol(szText);
    m_Edit_GOP_M.GetWindowText(szText,sizeof(szText));
    enc_video_param.EncodeParamEx.cPictureInterval = atoi(szText);
    m_Edit_GOP_N.GetWindowText(szText,sizeof(szText));
    enc_video_param.EncodeParamEx.cPicturePerGop = atoi(szText);

    //  rfIGR[hp[^̐ݒ
    //  Set video encode parameters
	enc_video_param.dwSize = sizeof(ENC_VIDEO_ENCODE_PARAMETER_EX2);
    enc_return = ENC_Set_Video_Encode_Parameter_Ex2(ENC_ID, &enc_video_param);
    if(enc_return != ENC_SUCCESS)
    {
        strMessage.LoadString(IDC_ERROR_SET_PARAMETER);
        MessageBox(strMessage);
        return;
    }
    
    CDialog::OnOK();
}
